com.amazonaws.services.elastictranscoder.model

## Class Encryption

- java.lang.Object
- - com.amazonaws.services.elastictranscoder.model.Encryption

All Implemented Interfaces:
  Serializable, Cloneable

    public class Encryption
    extends Object
    implements Serializable, Cloneable

The encryption settings, if any, that are used for decrypting your input files or encrypting your output files. If your input file is encrypted, you must specify the mode that Elastic Transcoder uses to decrypt your file, otherwise you must specify the mode you want Elastic Transcoder to use to encrypt your output files.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`Encryption()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Encryption` `clone()`
`boolean` `equals(Object obj)`
`String` `getInitializationVector()` The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files.
`String` `getKey()` The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file.
`String` `getKeyMd5()` The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file.
`String` `getMode()` The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files.
`int` `hashCode()`
`void` `setInitializationVector(String initializationVector)` The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files.
`void` `setKey(String key)` The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file.
`void` `setKeyMd5(String keyMd5)` The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file.
`void` `setMode(String mode)` The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`Encryption` `withInitializationVector(String initializationVector)` The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files.
`Encryption` `withKey(String key)` The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file.
`Encryption` `withKeyMd5(String keyMd5)` The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file.
`Encryption` `withMode(String mode)` The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Encryption

    public Encryption()

### Method Detail

#### setMode

    public void setMode(String mode)

The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files. Elastic Transcoder supports the following options:

- S3: Amazon S3 creates and manages the keys used for encrypting your files.

- S3-AWS-KMS: Amazon S3 calls the Amazon Key Management Service, which creates and manages the keys that are used for encrypting your files. If you specify `S3-AWS-KMS` and you don't want to use the default key, you must add the AWS-KMS key that you want to use to your pipeline.

- AES-CBC-PKCS7: A padded cipher-block mode of operation originally used for HLS files.

- AES-CTR: AES Counter Mode.

- AES-GCM: AES Galois Counter Mode, a mode of operation that is an authenticated encryption format, meaning that a file, key, or initialization vector that has been tampered with fails the decryption process.

For all three AES options, you must provide the following settings, which must be base64-encoded:

- Key

- Key MD5

- Initialization Vector

<important>

For the AES modes, your private encryption keys and your unencrypted data are never stored by AWS; therefore, it is important that you safely manage your encryption keys. If you lose them, you won't be able to unencrypt your data.

</important>

Parameters:
  `mode` - The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files. Elastic Transcoder supports the following options:

  - S3: Amazon S3 creates and manages the keys used for encrypting your files.

  - S3-AWS-KMS: Amazon S3 calls the Amazon Key Management Service, which creates and manages the keys that are used for encrypting your files. If you specify `S3-AWS-KMS` and you don't want to use the default key, you must add the AWS-KMS key that you want to use to your pipeline.

  - AES-CBC-PKCS7: A padded cipher-block mode of operation originally used for HLS files.

  - AES-CTR: AES Counter Mode.

  - AES-GCM: AES Galois Counter Mode, a mode of operation that is an authenticated encryption format, meaning that a file, key, or initialization vector that has been tampered with fails the decryption process.

  For all three AES options, you must provide the following settings, which must be base64-encoded:

  - Key

  - Key MD5

  - Initialization Vector

  <important>

  For the AES modes, your private encryption keys and your unencrypted data are never stored by AWS; therefore, it is important that you safely manage your encryption keys. If you lose them, you won't be able to unencrypt your data.

#### getMode

    public String getMode()

The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files. Elastic Transcoder supports the following options:

- S3: Amazon S3 creates and manages the keys used for encrypting your files.

- S3-AWS-KMS: Amazon S3 calls the Amazon Key Management Service, which creates and manages the keys that are used for encrypting your files. If you specify `S3-AWS-KMS` and you don't want to use the default key, you must add the AWS-KMS key that you want to use to your pipeline.

- AES-CBC-PKCS7: A padded cipher-block mode of operation originally used for HLS files.

- AES-CTR: AES Counter Mode.

- AES-GCM: AES Galois Counter Mode, a mode of operation that is an authenticated encryption format, meaning that a file, key, or initialization vector that has been tampered with fails the decryption process.

For all three AES options, you must provide the following settings, which must be base64-encoded:

- Key

- Key MD5

- Initialization Vector

<important>

For the AES modes, your private encryption keys and your unencrypted data are never stored by AWS; therefore, it is important that you safely manage your encryption keys. If you lose them, you won't be able to unencrypt your data.

</important>

Returns:
  The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files. Elastic Transcoder supports the following options:

  - S3: Amazon S3 creates and manages the keys used for encrypting your files.

  - S3-AWS-KMS: Amazon S3 calls the Amazon Key Management Service, which creates and manages the keys that are used for encrypting your files. If you specify `S3-AWS-KMS` and you don't want to use the default key, you must add the AWS-KMS key that you want to use to your pipeline.

  - AES-CBC-PKCS7: A padded cipher-block mode of operation originally used for HLS files.

  - AES-CTR: AES Counter Mode.

  - AES-GCM: AES Galois Counter Mode, a mode of operation that is an authenticated encryption format, meaning that a file, key, or initialization vector that has been tampered with fails the decryption process.

  For all three AES options, you must provide the following settings, which must be base64-encoded:

  - Key

  - Key MD5

  - Initialization Vector

  <important>

  For the AES modes, your private encryption keys and your unencrypted data are never stored by AWS; therefore, it is important that you safely manage your encryption keys. If you lose them, you won't be able to unencrypt your data.

#### withMode

    public Encryption withMode(String mode)

The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files. Elastic Transcoder supports the following options:

- S3: Amazon S3 creates and manages the keys used for encrypting your files.

- S3-AWS-KMS: Amazon S3 calls the Amazon Key Management Service, which creates and manages the keys that are used for encrypting your files. If you specify `S3-AWS-KMS` and you don't want to use the default key, you must add the AWS-KMS key that you want to use to your pipeline.

- AES-CBC-PKCS7: A padded cipher-block mode of operation originally used for HLS files.

- AES-CTR: AES Counter Mode.

- AES-GCM: AES Galois Counter Mode, a mode of operation that is an authenticated encryption format, meaning that a file, key, or initialization vector that has been tampered with fails the decryption process.

For all three AES options, you must provide the following settings, which must be base64-encoded:

- Key

- Key MD5

- Initialization Vector

<important>

For the AES modes, your private encryption keys and your unencrypted data are never stored by AWS; therefore, it is important that you safely manage your encryption keys. If you lose them, you won't be able to unencrypt your data.

</important>

Parameters:
  `mode` - The specific server-side encryption mode that you want Elastic Transcoder to use when decrypting your input files or encrypting your output files. Elastic Transcoder supports the following options:

  - S3: Amazon S3 creates and manages the keys used for encrypting your files.

  - S3-AWS-KMS: Amazon S3 calls the Amazon Key Management Service, which creates and manages the keys that are used for encrypting your files. If you specify `S3-AWS-KMS` and you don't want to use the default key, you must add the AWS-KMS key that you want to use to your pipeline.

  - AES-CBC-PKCS7: A padded cipher-block mode of operation originally used for HLS files.

  - AES-CTR: AES Counter Mode.

  - AES-GCM: AES Galois Counter Mode, a mode of operation that is an authenticated encryption format, meaning that a file, key, or initialization vector that has been tampered with fails the decryption process.

  For all three AES options, you must provide the following settings, which must be base64-encoded:

  - Key

  - Key MD5

  - Initialization Vector

  <important>

  For the AES modes, your private encryption keys and your unencrypted data are never stored by AWS; therefore, it is important that you safely manage your encryption keys. If you lose them, you won't be able to unencrypt your data.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setKey

    public void setKey(String key)

The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file. The key must be base64-encoded and it must be one of the following bit lengths before being base64-encoded:

`128`, `192`, or `256`.

The key must also be encrypted by using the Amazon Key Management Service.

Parameters:
  `key` - The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file. The key must be base64-encoded and it must be one of the following bit lengths before being base64-encoded:

  `128`, `192`, or `256`.

  The key must also be encrypted by using the Amazon Key Management Service.

#### getKey

    public String getKey()

The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file. The key must be base64-encoded and it must be one of the following bit lengths before being base64-encoded:

`128`, `192`, or `256`.

The key must also be encrypted by using the Amazon Key Management Service.

Returns:
  The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file. The key must be base64-encoded and it must be one of the following bit lengths before being base64-encoded:

  `128`, `192`, or `256`.

  The key must also be encrypted by using the Amazon Key Management Service.

#### withKey

    public Encryption withKey(String key)

The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file. The key must be base64-encoded and it must be one of the following bit lengths before being base64-encoded:

`128`, `192`, or `256`.

The key must also be encrypted by using the Amazon Key Management Service.

Parameters:
  `key` - The data encryption key that you want Elastic Transcoder to use to encrypt your output file, or that was used to encrypt your input file. The key must be base64-encoded and it must be one of the following bit lengths before being base64-encoded:

  `128`, `192`, or `256`.

  The key must also be encrypted by using the Amazon Key Management Service.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setKeyMd5

    public void setKeyMd5(String keyMd5)

The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file. Elastic Transcoder uses the key digest as a checksum to make sure your key was not corrupted in transit. The key MD5 must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

Parameters:
  `keyMd5` - The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file. Elastic Transcoder uses the key digest as a checksum to make sure your key was not corrupted in transit. The key MD5 must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

#### getKeyMd5

    public String getKeyMd5()

The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file. Elastic Transcoder uses the key digest as a checksum to make sure your key was not corrupted in transit. The key MD5 must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

Returns:
  The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file. Elastic Transcoder uses the key digest as a checksum to make sure your key was not corrupted in transit. The key MD5 must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

#### withKeyMd5

    public Encryption withKeyMd5(String keyMd5)

The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file. Elastic Transcoder uses the key digest as a checksum to make sure your key was not corrupted in transit. The key MD5 must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

Parameters:
  `keyMd5` - The MD5 digest of the key that you used to encrypt your input file, or that you want Elastic Transcoder to use to encrypt your output file. Elastic Transcoder uses the key digest as a checksum to make sure your key was not corrupted in transit. The key MD5 must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setInitializationVector

    public void setInitializationVector(String initializationVector)

The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files. The initialization vector must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

Parameters:
  `initializationVector` - The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files. The initialization vector must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

#### getInitializationVector

    public String getInitializationVector()

The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files. The initialization vector must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

Returns:
  The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files. The initialization vector must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

#### withInitializationVector

    public Encryption withInitializationVector(String initializationVector)

The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files. The initialization vector must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.

Parameters:
  `initializationVector` - The series of random bits created by a random bit generator, unique for every encryption operation, that you used to encrypt your input files or that you want Elastic Transcoder to use to encrypt your output files. The initialization vector must be base64-encoded, and it must be exactly 16 bytes long before being base64-encoded.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public Encryption clone()

Overrides:
  `clone` in class `Object`